Lua_RoleLevelUpWindow = class("Lua_RoleLevelUpWindow", Lua_Window);
function Lua_RoleLevelUpWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_RoleLevelUpWindow";
	self.skinName = "RoleLevelUpWindow_skin";
	self.showBlackMask = true;
	self.isClickClose = true;
end

function Lua_RoleLevelUpWindow:buildShowItem()
	self:superCall("buildShowItem");
	self.winBg:SetDimensions(0, 0);

	self.rItem = Lua_ItemIconList.new(self.content);
	self.rItem:setLocation(0, 110, 0);
end

function Lua_RoleLevelUpWindow:dispose()
	if self.rItem ~= nil then
		self.rItem:dispose();
		self.rItem = nil;
	end
	if self.noticeArr ~= nil then
		self.noticeArr:dispose();
		self.noticeArr:clear();
		self.noticeArr = nil;
	end
	Lua_MsgUtil.callFunc("GUIDE_TRIGGER_LEVEL", self.showData);
	self:superCall("dispose");
end

function Lua_RoleLevelUpWindow:showWin(param)
	self:superCall("showWin", param);
	self.prevLevel.text = LanUtil.formateStr(350000, tostring(param - 1));
	self.curLevel.text = LanUtil.formateStr(350000, tostring(param));

	local vo = DataCenter.roleUtil:getRoleVoByLv(param);
	local rewardConfig = Lua_RewardConfigData.getConfigDataById(vo.reward);
	if rewardConfig ~= nil then
		self.rItem:setArrayData(rewardConfig.rewardsArr);
	end

	if vo.notices == nil or #vo.notices <= 0 then
		self.winBg:setUrl("/images/common/ui_common_window_038.png");
		self.text_3:setEnable(false);
		self.line_2:setEnable(false);
	else
		self.winBg:setUrl("/images/common/ui_common_window_037.png");
		self.text_3:setEnable(true);
		self.line_2:setEnable(true);

		if self.noticeArr == nil then
			self.noticeArr = Array();
			local len = #vo.notices;
			local item;
			local posX;
			local posY;
			for i = 1, len do
				item = Lua_RoleLevelUpNoticeItem.new(self.content);
				item:setData(vo.notices[i]);
				posX = -276 + ((i - 1) % 2) * 334;
				posY = -99 + Mathf.Floor((i - 1) / 2) * -116;
				if len == 1 then
					item:setLocation(-120, -155, 0);
				elseif len == 2 then
					item:setLocation(posX, -155, 0);
				else
					item:setLocation(posX, posY, 0);
				end
				self.noticeArr:add(item);
			end
		end
	end
end




















Lua_RoleLevelUpNoticeItem = class("Lua_RoleLevelUpNoticeItem", Lua_DisplayObject);
function Lua_RoleLevelUpNoticeItem:ctor(p)
	self:superCall("ctor", p, "RoleLevelUpNoticeItem_skin");
end

function Lua_RoleLevelUpNoticeItem:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_RoleLevelUpNoticeItem:dispose()
	self:superCall("dispose");
end

function Lua_RoleLevelUpNoticeItem:setData(data)
	if data == nil then
		return;
	end

	local vo = DataCenter.funcOpenUtil:getFuncOpenVoById(data);
	self.name.text = vo.name;
	self.des.text = vo.des;

	if vo.iconId == nil then
		self.icon:setEnable(false);
	else
		vo = DataCenter.mainMenuData:getMenuIconVo(vo.iconId, vo.iconId);
		self.icon:setEnable(true);
		self.icon:setAltas(vo.iconAtlas, vo.iconSprite);
	end
end