Lua_RolePanel = class("Lua_RolePanel", Lua_DisplayObject);
function Lua_RolePanel:ctor(p)
	self:superCall("ctor", p, "RolePanel_skin");
end

function Lua_RolePanel:buildShowItem()
	self:superCall("buildShowItem");

	self.attrList = Lua_DragList.new(self.content, 720, 34, Lua_AxisDefine.Vertical);
	self.attrList:setRectAnchor(7);
	self.attrList:setLocation(0, 290, 0);
	self.attrList:setListCell(Lua_RoleAttrItem, 360, 34, 2);

	self:addLuaEvent("UPDATE_ROLE_INFO", self, self.updateShowInfo);
	self:addLuaEvent("UPDATE_ROLE_FORCE", self, self.updateShowInfo);
	if DataCenter.roleData.bInitRoleData then
		self:updateShowInfo();
	else
		Lua_ProxyManager.getProxy("Lua_RoleProxy"):sRoleInfo();
	end

	self.btnHelp:addClickFuntion(self, self.onHelpClick);
end

function Lua_RolePanel:dispose()
	if self.attrList ~= nil then
		self.attrList:dispose();
		self.attrList = nil;
	end
	self:superCall("dispose");
end

function Lua_RolePanel:updateShowInfo()
	local roleData = DataCenter.roleData;
	self.forceText.text = roleData.leaderForce;

	local vo = DataCenter.roleUtil:getFateVoById(roleData.curFaceId);
	self.fateText.text = LanUtil.formateStr(350004, vo.name, convert_arab_to_chinese(vo.level));

	local arr = DataCenter.attributesUtil:getAttrArrByServer(roleData.prop_list);
	self.attrList:setArrayData(arr);
	self.attrList.canDrag = not self.attrList.bDragEnd;

	arr:clear();
	arr = nil;
end

function Lua_RolePanel:onHelpClick(go)
	local tipsData = { des = LanUtil.getValue(350005), isBottomShow = true, posX = 200, posY = 310 };
	Lua_WindowUtil.openWin("Lua_InstructionTipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
end




















Lua_RoleAttrItem = class("Lua_RoleAttrItem", Lua_ListCell);
function Lua_RoleAttrItem:ctor(p)
	self:superCall("ctor", p, "RoleAttrItem_skin");
end

function Lua_RoleAttrItem:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_RoleAttrItem:dispose()
	self:superCall("dispose");
end

function Lua_RoleAttrItem:setData(data)
	if data == nil then
		return;
	end
	
	self.icon:setAltas("common_altas_2", data.hero_attr_icon);
	self.nameText.text = data.show_name;
	self.nameText:resetSize();
	self.valueText:setLocation(self.nameText.posX + self.nameText.width + 10, 0, 0);
	self.valueText.text = "+"..data.showValue;
	self.valueText:resetSize();
end