checkRequire("Lua_RolePanel");
checkRequire("Lua_RoleFatePanel");
checkRequire("Lua_ArtifactPanel");
Lua_RoleWindow = class("Lua_RoleWindow", Lua_Window);
function Lua_RoleWindow:ctor()
	self:superCall("ctor");

	self.layer = MainWinDefine.MAIN_WINDOW_LAYER;
	self.windowName = "Lua_RoleWindow";
	self.isFullSizeWin = true;
	self.showWinBg = true;
	self.winBgPath = "";
	self.openSound = "bgm_zhucheng";
	self.closeSound = "";
end

function Lua_RoleWindow:buildShowItem()
	self:superCall("buildShowItem");
	LuaUtil.setSceneDataExtendVal("FurEffShow", true);

	self.btnInfo = Array();
	self.btnInfo:add({ panel = Lua_RolePanel, textStr = LanUtil.getValue(350001) });
	self.btnInfo:add({ panel = Lua_RoleFatePanel, textStr = LanUtil.getValue(350002), openId = 10210, bgPath = "/images/raccoon/ui_hx_bg_02.jpg", redPointId = Lua_RedPointList.Fate });
	self.btnInfo:add({ panel = Lua_ArtifactPanel, textStr = LanUtil.getValue(350003), openId = 10209, redPointId = Lua_RedPointList.Artifact });

	self.btnList = Lua_ButtonList.new(self.content, Lua_AxisDefine.Horizontal);
	self.btnList:setRectAnchor(7);
	self.btnList:setLocation(0, 157, 0);
	self.btnList:setButtonBg("raccoon_atlas_1", "ui_hx_tab_01_s", 720, 63)
    self.btnList:setButtonStyle("common_altas_1", "ui_common_tab_01", "ui_common_tab_01", 240, 67, 0.001);
    self.btnList:setButtonLine("common_altas_1", "ui_common_line_014");
    self.btnList:setRedPoint(105, 20);
    self.btnList:setButtonItem(240, 67);
	self.btnList:setClickCallBack(self, self.onBtnClick);
	self.btnList:setData(self.btnInfo);

	self:addLuaEvent("ARTIFACT_SELECT", self, self.onArtifactSelected)
end

function Lua_RoleWindow:dispose()
	LuaUtil.setSceneDataExtendVal("FurEffShow", false);
	if self.curPanel ~= nil then
		self.curPanel:dispose();
		self.curPanel = nil;
	end
	if self.btnList ~= nil then
		self.btnList:dispose();
		self.btnList = nil;
	end
	if self.btnInfo ~= nil then
		self.btnInfo:clear();
		self.btnInfo = nil;
	end
	if self.modelScenePanel then
		self.modelScenePanel:dispose()
		self.modelScenePanel = nil
	else
		local arr = Lua_WindowUtil.getWinListData(self.windowName, true)
		if arr then
			for i = 1, arr:getSize() do
				if arr[i].modelScenePanel then
					arr[i].modelScenePanel:dispose()
					arr[i].modelScenePanel = nil
				end
			end
		end
	end
	self.uiModelSrc = nil
	self:superCall("dispose");
end

function Lua_RoleWindow:resetActive(bActive)
	self:superCall("resetActive", bActive);
	LuaUtil.setSceneDataExtendVal("FurEffShow", bActive);
	if bActive then
		AudioManager.instance:play(self.openSound);
	end
end

function Lua_RoleWindow:showWin(param)
	self:superCall("showWin", param);

	local index;
	if type(param) == "table" then
		index = param.main_id;

		if param.modelScenePanel then
			if self.modelScenePanel ~= nil and self.modelScenePanel ~= param.modelScenePanel then
				self.modelScenePanel:dispose();
				self.modelScenePanel = nil;
			end
			
			self.modelScenePanel = param.modelScenePanel
			self.modelScenePanel:setParent(self.content)
			self.modelScenePanel:setRotBgDimensions(720, 720)
			self.modelScenePanel:setRotBgPos(0, 130)
			param.modelScenePanel = nil
		end
	elseif type(param) == "number" then
		index = param;
	end
	index = index == nil and 1 or index;
	self.btnList:setSelected(index);
end

function Lua_RoleWindow:onScreenResize()
	self:superCall("onScreenResize");
	if self.curPanel then
		self.curPanel:setRectSize(self.width, self.height);
	end
end

function Lua_RoleWindow:onBtnClick(index)
	local data = self.btnInfo[index]
	self.winBg:setUrl(data.bgPath)

	if self.curPanel then
		self.curPanel:dispose()
		self.curPanel = nil
	end

	if index == 1 then
		local vo = DataCenter.artifactUtil:getArtifactVoById(999)
		self:showModel(vo)
	end
	if index == 2 then
		self.winBg:setLocation(0, 32, 0);
	else
		self.winBg:setLocation(0, 0, 0);
	end
	self.curPanel = data.panel.new(self.content)
	self.curPanel:setRectSize(self.width, self.height)
	UIUtils.swapObjSiblingIndex(self.btnList.mainContent, self.curPanel.mainContent)
end

function Lua_RoleWindow:showModel(data)
	if self.modelScenePanel == nil then
		self.modelScenePanel = Lua_ModelScenePanel.new()
		self.modelScenePanel:setParent(self.content)
		self.modelScenePanel:setRotBgDimensions(720, 720)
		self.modelScenePanel:setRotBgPos(0, 130)
	end

	if self.uiModelUrl == data.uiModelUrl then
		return
	end
	self.uiModelUrl = data.uiModelUrl
	if data.id == 301 then
		self.modelScenePanel:setLocation(0, -0.3, 0)
	else
		self.modelScenePanel:setLocation(0, 0, 0)
	end
	self.modelScenePanel:addActIdEffs(Lua_ThingDefine.UIWAIT, data.poseActEffs)
	self.modelScenePanel:addActIdEffs(Lua_ThingDefine.UISHOW, data.showActEffs)
	self.modelScenePanel:showModelScene(data.uiSceneId, data.uiModelUrl, data.uiModelAvatarName, data.uiModelCamController, true)
	self.modelScenePanel:setModelAct(data.uiShowAct, Lua_ThingDefine.UIWAIT, true)
	self.modelScenePanel:setModelDir(data.uiModelDir)
end

function Lua_RoleWindow:onArtifactSelected(data)
	self:showModel(data)
end