-- 神器总览
Lua_ArtifactOverviewWindow = class("Lua_ArtifactOverviewWindow", Lua_Window);
function Lua_ArtifactOverviewWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_ArtifactOverviewWindow";
	self.skinName = "ArtifactOverviewWindow_skin";
	self.showBlackMask = true;
	self.maskSprite = "black_mask";
	self.blackAlpha = 0.98;
	self.isClickClose = true;
end

function Lua_ArtifactOverviewWindow:buildShowItem()
	self:superCall("buildShowItem");
	self:addLuaEvent("ARTIFACT_OVERVIEW_ITEM_SELECT", self, self.updateShowInfo);

	self.roleImg = UICreate.createImage(self.content, nil, -20, 260, 0, 0);

	self.itemArr = Array();
	local posDic = {{0, -215, 1}, {158, -142.5, 0.9}, {-154.5, -142.5, 0.9}, {272.5, -88, 0.7}, {-272, -88, 0.7}};
	local arr = DataCenter.artifactUtil:getArtifactArr();
	local item;
	for i = 1, arr:getSize() do
		item = Lua_ArtifactOverviewItem.new(self.content);
		item:setLocation(posDic[i][1], posDic[i][2]);
		item:setScale(posDic[i][3], posDic[i][3]);
		item:setData(arr[i]);
		self.itemArr:add(item);
	end
	self.itemArr[1]:onPressClick();
end

function Lua_ArtifactOverviewWindow:dispose()
	if self.itemArr ~= nil then
		self.itemArr:dispose();
		self.itemArr:clear();
		self.itemArr = nil;
	end
	self:superCall("dispose");
end

function Lua_ArtifactOverviewWindow:updateShowInfo(data)
	for i = 1, self.itemArr:getSize() do
		self.itemArr[i]:setSelected(self.itemArr[i].data == data);
	end

	self.roleImg:setUrl(data.image_3)
	self.nameText.text = LanUtil.formateStr(350021, data.name);
	self.desText.text = data.des;
end










Lua_ArtifactOverviewItem = class("Lua_ArtifactOverviewItem", Lua_DisplayObject);
function Lua_ArtifactOverviewItem:ctor(p)
	self:superCall("ctor", p, "ArtifactOverviewItem_skin");
end

function Lua_ArtifactOverviewItem:buildShowItem()
	self:superCall("buildShowItem");
	self.icon:addClickFuntion(self, self.onPressClick);
end

function Lua_ArtifactOverviewItem:dispose()
	self.data = nil;
	self:superCall("dispose");
end

function Lua_ArtifactOverviewItem:setData(data)
	self.data = DataCenter.artifactUtil:getArtifactVoById(data);

	self.icon:setAltas("raccoon_atlas_3", self.data.weapon_icon);
	self.icon:setGray(self.data.is_activate == 0);

	local dic = DataCenter.heroLineupData:getServerArtifactDic(Lua_HeroUtil.LINEUP_MAIN_TYPE);
	local teamIdx = DataCenter.heroLineupData:getArtifactTeamIdx(dic, data);
	self.signIcon:setEnable(teamIdx ~= nil);
end

function Lua_ArtifactOverviewItem:setSelected(bSelected)
	self.selectIcon:setEnable(bSelected);
end

function Lua_ArtifactOverviewItem:onPressClick()
	Lua_MsgUtil.callFunc("ARTIFACT_OVERVIEW_ITEM_SELECT", self.data);
end