-- 神器培养
-- checkRequire("Lua_ArtifactSkillList");
Lua_ArtifactPanel = class("Lua_ArtifactPanel", Lua_DisplayObject);
function Lua_ArtifactPanel:ctor(p)
	self:superCall("ctor", p, "ArtifactPanel_skin");
end

function Lua_ArtifactPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.artifactArr = DataCenter.artifactUtil:getArtifactArr();
	self.artifactLen = self.artifactArr:getSize();
	self.selectIdx = 1;
	local artifactId = DataCenter.artifactUtil:getMainLineArtifact()
	for i = 1, self.artifactLen do
		if self.artifactArr[i] == artifactId then
			self.selectIdx = i;
			break;
		end
	end

	self.upgradeBar.typeValue = 3;
    self.upgradeBar.fillMethodValue = 0;
    self.upgradeBar.fillOrigin = 0;
	self.upgradeBar:addRectMask2D();
	self.upgradeBar:createSlider("raccoon_atlas_2", "ui_hx_progress_001_m", -27.5, 0);
	self.upgradeBar:setMouseEnable(false);

	self:addLuaEvent("UPDATE_ARTIFACT_INFO", self, self.updateShowInfo);
	self:addLuaEvent("UPDATE_SINGLE_ARTIFACT_INFO", self, self.updateShowArtifact);
	self:addLuaEvent("ARTIFACT_SELECT", self, self.onArtifactSelected);

	-- self.circleList = Lua_ArtifactSkillList.new(self.content, 720, 250);
	-- self.circleList:setLocation(0, 90, 0);
	-- self.circleList:setSubPos(0, 125, 0);
	-- self.circleList.r_small = 180;
	-- self.circleList.r_big = 300;
	-- self.circleList.angle = -90;
	-- self.circleList.moveSpd = 10;
	-- self.circleList:setListCell(Lua_ArtifactSkillItem, 112, 112);

	-- self.redPointClothes = Lua_RedPointIcon.new(self.content, Lua_RedPointList.Artifact_Clothes);
	-- self.redPointClothes:setRectAnchor(1);
	-- self.redPointClothes:setLocation(320, -190);

	self.artifactList = Lua_DragList.new(self.content, 522, 57, Lua_AxisDefine.Horizontal);
	self.artifactList:setRectAnchor(7);
	self.artifactList:setLocation(-80, 502.5, 0);
	self.artifactList:setListCell(Lua_ArtifactItem, 174, 57, 1);

	self.attrList = Lua_DragList.new(self.content, 720, 34, Lua_AxisDefine.Vertical);
	self.attrList:setRectAnchor(7);
	self.attrList:setLocation(0, 381, 0);
	self.attrList:setListCell(Lua_ArtifactAttrItem, 360, 34, 2);

	self.btnLess:setEnable(false);
	self.btnPlus:setEnable(false);
	self.btnIllusion:setEnable(false);

	self.btnLess:addClickFuntion(self, self.onBtnLessClick);
	self.btnPlus:addClickFuntion(self, self.onBtnPlusClick);
	self.checkHelp:addClickFuntion(self, self.onCheckHelp);
	self.btnOverview:addClickFuntion(self, self.onBtnOverviewClick);
	self.btnRecast:addClickFuntion(self, self.onBtnRecastClick);
	self.btnIllusion:addClickFuntion(self, self.onBtnIllusionClick);
	self.btnFunc:addMousDownFuntion(self, self.onMouseDownFun);
	self.btnFunc:addMouseUpFuntion(self, self.onMouseUpFun);

	Lua_ProxyManager.getProxy("Lua_ArtifactProxy"):sArtifactInfo();
end

function Lua_ArtifactPanel:dispose()
	self:removeLongPressTimer();
	if self.circleList ~= nil then
		self.circleList:dispose();
		self.circleList = nil;
	end
	if self.artifactList ~= nil then
		self.artifactList:dispose();
		self.artifactList = nil;
	end
	if self.attrList ~= nil then
		self.attrList:dispose();
		self.attrList = nil;
	end
	if self.skillArr ~= nil then
		self.skillArr:dispose();
		self.skillArr:clear();
		self.skillArr = nil;
	end
	if self.costArr ~= nil then
		self.costArr:dispose();
		self.costArr:clear();
		self.costArr = nil;
	end
	if self.redPointClothes ~= nil then
		self.redPointClothes:dispose();
		self.redPointClothes = nil;
	end
	if self.lessRedPoint ~= nil then
		self.lessRedPoint:dispose();
		self.lessRedPoint = nil;
	end
	if self.plusRedPoint ~= nil then
		self.plusRedPoint:dispose();
		self.plusRedPoint = nil;
	end
	if self.redPoint ~= nil then
		self.redPoint:dispose();
		self.redPoint = nil;
	end
	self.data = nil;
	self:superCall("dispose");
end

function Lua_ArtifactPanel:onScreenResize(adaptHeight)
	self:superCall("onScreenResize", adaptHeight);
end

function Lua_ArtifactPanel:updateShowInfo()
	self:removeLongPressTimer();
	self.data = nil;

	self.artifactList.canDrag = self.artifactLen > 5;
	self.artifactList:setArrayData(self.artifactArr);
	self:setSelected();
end

function Lua_ArtifactPanel:setSelected()
	self.artifactList:moveToIndex(self.selectIdx, true);
	self.artifactList:setSelectClick(self.selectIdx);
	self.artifactList:setSelected(self.selectIdx);
end

function Lua_ArtifactPanel:onArtifactSelected(data)
	if self.data == data then
		return;
	end
	self.data = data;

	for i = 1, self.artifactLen do
		if self.artifactArr[i] == data.id then
			self.selectIdx = i;
			break;
		end
	end
	self.artifactList:moveToIndex(self.selectIdx, false);
	self.btnLess:setEnable(self.selectIdx > 1);
	self.btnPlus:setEnable(self.selectIdx < self.artifactLen);
	if self.selectIdx > 1 then
		local index = self.selectIdx - 1;
		local vo = DataCenter.artifactUtil:getArtifactVoById(self.artifactArr[index]);
		self:showLessRedDot(vo.canUpgrade);
	else
		self:showLessRedDot(false);
	end
	if self.selectIdx < self.artifactLen then
		local index = self.selectIdx + 1;
		local vo = DataCenter.artifactUtil:getArtifactVoById(self.artifactArr[index]);
		self:showPlusRedDot(vo.canUpgrade);
	else
		self:showPlusRedDot(false);
	end

	self:updateShowArtifact();
end

function Lua_ArtifactPanel:showLessRedDot(bShow)
	if bShow == true then
		if self.lessRedPoint == nil then
			self.lessRedPoint = Lua_RedPointIcon.new(self.content);
			self.lessRedPoint:setRectAnchor(1);
			self.lessRedPoint:setLocation(-325, -466, 0);
			self.lessRedPoint:createRedPointEff();
		end
		self.lessRedPoint:updateRedPointShow(true);
	else
		if self.lessRedPoint ~= nil then
			self.lessRedPoint:updateRedPointShow(false);
		end
	end
end

function Lua_ArtifactPanel:showPlusRedDot(bShow)
	if bShow == true then
		if self.plusRedPoint == nil then
			self.plusRedPoint = Lua_RedPointIcon.new(self.content);
			self.plusRedPoint:setRectAnchor(1);
			self.plusRedPoint:setLocation(325, -466, 0);
			self.plusRedPoint:createRedPointEff();
		end
		self.plusRedPoint:updateRedPointShow(true);
	else
		if self.plusRedPoint ~= nil then
			self.plusRedPoint:updateRedPointShow(false);
		end
	end
end

function Lua_ArtifactPanel:updateShowArtifact()
	self:showRedDot(self.data.canUpgrade);
	self:showSkill(self.data.skill_list);

	self.name.text = self.data.name;
	self.name:resetSize();
	self.level:setLocation(self.name.posX + self.name.width + 10, -177.5, 0);
	self.level.text = LanUtil.formateStr(10041, self.data.level);
	self.position.text = self.data.position;
	self.btnRecast:setEnable(self.data.canRecast);

	local roleAttrDic = {};
	local heroAttrDic = {};
	DataCenter.attributesUtil:getAttrDicByServer(self.data.role_props, nil, roleAttrDic);
	DataCenter.attributesUtil:getAttrDicByServer(self.data.hero_props, nil, heroAttrDic);

	local arr = Array();
	DataCenter.roleUtil:getAttrArr3(roleAttrDic, 1, arr);
	DataCenter.roleUtil:getAttrArr3(heroAttrDic, 2, arr);

	arr:sort("sortNum", false);
	self.attrList:setArrayData(arr);
	self.attrList.canDrag = not self.attrList.bDragEnd;

	if self.data.bMaxLv then
		self:removeLongPressTimer();
		self.upgradeBar:setMaxValue(1);
		self.upgradeBar:setValue(1);
		self.upgradeBar:setLangValue(350032);		
		self.btnFunc:setEnable(false);
		self.prompt:setEnable(false);
		self:showConsumeInfo(nil);
	else
		local lvl_progress_rate = DataCenter.artifactUtil:getArtifactCostConfig("lvl_progress_rate", 1);
		local maxValue = self.data.levelConfig.lvlup_times * lvl_progress_rate;
		local value = self.data.lvl_progress;
		self.upgradeBar:setMaxValue(maxValue);
		self.upgradeBar:setValue(value);
		self.upgradeBar:setText(value.."/"..maxValue);

		self.btnFunc:setEnable(true);
		local roleLv = DataCenter.roleData.level;
		local targetLv = self.data.levelConfig.leader_level;
		if targetLv > roleLv then
			self.btnFunc:setMouseEnable(false);
			self.btnFunc:setStyle(7);
			self.prompt:setEnable(true);
			self.prompt.text = LanUtil.formateStr(350014, tostring(targetLv), tostring(targetLv + 1));
			self:showConsumeInfo(nil);
		else
			self.btnFunc:setMouseEnable(true);
			self.btnFunc:setStyle(5);
			self.prompt:setEnable(false);
			self:showConsumeInfo(self.data.levelConfig.lvlup_cost);
		end
	end
end

function Lua_ArtifactPanel:showRedDot(bShow)
	if bShow == true then
		if self.redPoint == nil then
			self.redPoint = Lua_RedPointIcon.new(self.content);
			self.redPoint:setRectAnchor(7);
			self.redPoint:setLocation(90, 315, 0);
			self.redPoint:createRedPointEff();
		end
		self.redPoint:updateRedPointShow(true);
	else
		if self.redPoint ~= nil then
			self.redPoint:updateRedPointShow(false);
		end
	end
end

function Lua_ArtifactPanel:showSkill(list)
	local arr = Array();
	if list ~= nil then
		local data;
		for i = 1, #list do
			data = { id = list[i][1], level = list[i][2], state = self.data.level >= list[i][2] };
			arr:add(data);
		end
	end

	if self.skillArr == nil then
		self.skillPos = {{0, -29, 1}, {163.5, -18, 1}, {296, 39.5, 0.9}, {-295, 39.5, 0.9}, {-163.5, -18, 1}};
		self.skillArr = Array();
	end
	local len = self.skillArr:getSize();
	local dataLen = arr:getSize();
	local maxLen = dataLen > len and dataLen or len;
	local item;
	for i = 1, maxLen do
		item = self.skillArr[i];
		if i > dataLen then
			if item ~= nil then
				item:setEnable(false);
			end
		else
			if item == nil then
				item = Lua_ArtifactSkillItem.new(self.content);
				self.skillArr:add(item);
			else
				item:setEnable(true);
			end
			item:setData(arr[i]);
			item:setLocation(self.skillPos[i][1], self.skillPos[i][2], 0);
			item:setScale(self.skillPos[i][3], self.skillPos[i][3], 0);
		end
	end

	-- self.circleList:setData(arr);
end

function Lua_ArtifactPanel:showConsumeInfo(data)
	if self.costArr == nil then
		self.costArr = Array();
	end

	local len = self.costArr:getSize();
	if data == nil then
		len = -len;
	else
		len = #data - len;
	end
	
	while (len > 0) do
		item = Lua_ConsumeIconItem.new(self.content);
		item.joinerStr = " / ";
		item:setStyle(Lua_MyUISettings.defaultFontName, 22, "FFFFFF", 2, "2B3136", 2, 2);
		item:setColorStr("2FC548", "FB524B");
		self.costArr:add(item);
		len = len - 1;
	end

	while (len < 0) do
		item = self.costArr:remove(1);
		item:dispose();
		len = len + 1;
	end

	len = self.costArr:getSize();
	local space = 300;
	local w = -(space * len) / 2 + space / 2;
	local posX;
	for i = 1, len do
		item = self.costArr[i];
		item:setData(data[i]);
		
		posX = ((i - 1) % len) * space + w;
		item:setRectAnchor(7);
		item:setLocation(posX, 241, 0);
	end
end

function Lua_ArtifactPanel:onBtnLessClick(go)
	if self.selectIdx <= 1 then
		return;
	end

	local index = self.selectIdx - 1;
	local data = DataCenter.artifactUtil:getArtifactVoById(self.artifactArr[index]);
	if data == nil or data.is_activate == 0 then
		OperateAlert.showLangValue(350015);
		return;
	end

	self.selectIdx = index;
	self:setSelected();
end

function Lua_ArtifactPanel:onBtnPlusClick(go)
	if self.selectIdx >= self.artifactLen then
		return;
	end

	local index = self.selectIdx + 1;
	local data = DataCenter.artifactUtil:getArtifactVoById(self.artifactArr[index]);
	if data == nil or data.is_activate == 0 then
		OperateAlert.showLangValue(350015);
		return;
	end

	self.selectIdx = index;
	self:setSelected();
end

function Lua_ArtifactPanel:onCheckHelp(go)
	local tipsData = { posX = 185, posY = -270, des = LanUtil.getValue(350017) };
	Lua_WindowUtil.openWin("Lua_InstructionTipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
end


function Lua_ArtifactPanel:onBtnOverviewClick(go)
	Lua_WindowUtil.openWin("Lua_ArtifactOverviewWindow", Lua_WinParam.ACTION_OPEN);
end

function Lua_ArtifactPanel:onBtnRecastClick(go)
	if self.data == nil then
		return;
	end

	local tipsData = { des = LanUtil.getValue(350016), posY = 40, btnType = 1, owner = self, sureFun = self.onConfirmRecast };
	Lua_WindowUtil.openWin("Lua_ArtifactRecastTipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
end

function Lua_ArtifactPanel:onConfirmRecast(param)
	if DataCenter.artifactData.reset_free_times > 0 then
		Lua_ProxyManager.getProxy("Lua_ArtifactProxy"):sRecast(self.data.id);
	else
		local costList = DataCenter.artifactUtil:getArtifactCostConfig("reset_cost", 2);
		local costId, costCount = DataCenter.packData:checkConsumeEnough(costList);
		if costId == nil then
			Lua_ProxyManager.getProxy("Lua_ArtifactProxy"):sRecast(self.data.id);
		else
			DataCenter.packUtil:openPathWindow(costId, false);
		end
	end
end

function Lua_ArtifactPanel:onBtnIllusionClick(go)
	if self.data == nil then
		return;
	end
	Lua_WindowUtil.openWin("Lua_ArtifactClothesWindow", Lua_WinParam.ACTION_OPEN, self.data.id);
end

function Lua_ArtifactPanel:onMouseDownFun(go)
	if self.data == nil then
		return;
	end

	self:startLongPressTimer();
end

function Lua_ArtifactPanel:onMouseUpFun(go)
	self:removeLongPressTimer();
	if self.bLongPress ~= true then
		self:onUpgrade();
	end
	self.bLongPress = false;
end

function Lua_ArtifactPanel:startLongPressTimer()
    if self.bLongPressTimer ~= true then
        self.bLongPressTimer = true;
         self.startClickTime = getTime();
        self:addTimer("Lua_ArtifactPanel_LongPress", 0.2, self, self.onLongPress, nil, -1);
    end
end

function Lua_ArtifactPanel:removeLongPressTimer()
    if self.bLongPressTimer == true then
        self.bLongPressTimer = false;
        self:removeTimer(self, self.onLongPress);
    end
end

function Lua_ArtifactPanel:onLongPress()
    if getTime() - self.startClickTime > 0.3 then
        self.bLongPress = true;
        self:onUpgrade();
    end
end

function Lua_ArtifactPanel:onUpgrade()
	local costId, costCount = DataCenter.packData:checkConsumeEnough(self.data.levelConfig.lvlup_cost);
	if costId == nil then
		Lua_ProxyManager.getProxy("Lua_ArtifactProxy"):sUpgrade(self.data.id);
	else
		self:removeLongPressTimer();
		DataCenter.packUtil:openPathWindow(costId, false);
	end
end




















Lua_ArtifactItem = class("Lua_ArtifactItem", Lua_ListCell);
function Lua_ArtifactItem:ctor(p)
	self:superCall("ctor", p, "ArtifactItem_skin");
end

function Lua_ArtifactItem:buildShowItem()
	self:superCall("buildShowItem");
	self:addLuaEvent("UPDATE_SINGLE_ARTIFACT_INFO", self, self.updateData);
end

function Lua_ArtifactItem:dispose()
	if self.redPoint ~= nil then
		self.redPoint:dispose();
		self.redPoint = nil;
	end
	self.data = nil;
	self:superCall("dispose");
end

function Lua_ArtifactItem:setData(data)
	self.data = DataCenter.artifactUtil:getArtifactVoById(data);
	self:updateData();
end

function Lua_ArtifactItem:updateData()
	if self.data == nil then
		return;
	end
	
	if self.data.is_activate == 0 then
		self.btnText.text = self.data.name;
	else
		self.btnText.text = self.data.name.." "..self.data.level;
	end
	self.lockIcon:setEnable(self.data.is_activate == 0);
	self:showRedDot(self.data.canUpgrade);
end

function Lua_ArtifactItem:showRedDot(bShow)
	if bShow == true then
		if self.redPoint == nil then
			self.redPoint = Lua_RedPointIcon.new(self.content);
			self.redPoint:setLocation(72, 12, 0);
			self.redPoint:createRedPointEff();
		end
		self.redPoint:updateRedPointShow(true);
	else
		if self.redPoint ~= nil then
			self.redPoint:updateRedPointShow(false);
		end
	end
end

function Lua_ArtifactItem:onSelectionChange(bSelect)
    self:superCall("onSelectionChange", bSelect);
	if bSelect == true then
		self.btnImg:setAltas("common_altas_1", "xui_common_toggle_003_f");
		self.btnText:setLocation(-62, -8, 0);
		self.btnText.fontSize = 30;
		self.btnText.colorStr = Lua_ColorDefine.transColorStr("894E23");
	else
		self.btnImg:setAltas("common_altas_1", "xui_common_toggle_003_b");
		self.btnText:setLocation(-60, -7, 0);
		self.btnText.fontSize = 28;
		self.btnText.colorStr = Lua_ColorDefine.transColorStr("B2B0A6");
	end
end

function Lua_ArtifactItem:onPressClick()
	if self.data == nil or self.data.is_activate == 0 then
		OperateAlert.showLangValue(350015);
		return false;
	end
	Lua_MsgUtil.callFunc("ARTIFACT_SELECT", self.data);
	return true;
end




















Lua_ArtifactSkillItem = class("Lua_ArtifactSkillItem", Lua_DisplayObject);
function Lua_ArtifactSkillItem:ctor(p)
	self:superCall("ctor", p, "ArtifactSkillItem_skin");
end

function Lua_ArtifactSkillItem:buildShowItem()
	self:superCall("buildShowItem");
	self.icon:addClickFuntion(self, self.onPressClick);
end

function Lua_ArtifactSkillItem:dispose()
	self.data = nil;
	self:superCall("dispose");
end

function Lua_ArtifactSkillItem:setData(data)
	self.data = data;

	local config = Lua_SkillConfigData.getConfigData(data.id);
	if data.state == true then
		self.iconBg:setAltas("raccoon_atlas_2", "ui_hx_widget_014");
		self.icon:setEnable(true);
		self.icon:setAltas(config.atlas, config.sprite);
		self.icon:resetSize();
		self.typeBg:setEnable(true);
		self.typeText:setEnable(true);
		if config.skillType == 3 then
			self.typeText:setLangValue(350018);
		elseif config.skillType == 2 then
			self.typeText:setLangValue(350019);
		else
			self.typeBg:setEnable(false);
			self.typeText:setEnable(false);
		end
		self.unlockText:setEnable(false);
	else
		self.iconBg:setAltas("raccoon_atlas_2", "ui_hx_widget_012");
		self.icon:setEnable(false);
		self.typeBg:setEnable(false);
		self.typeText:setEnable(false);
		self.unlockText:setEnable(true);
		self.unlockText.text = LanUtil.formateStr(350020, tostring(data.level));
	end
end

function Lua_ArtifactSkillItem:onPressClick()
	if self.data ~= nil and self.data.state == true then
		Lua_WindowUtil.openWin("Lua_SkillTipsWindow", Lua_WinParam.ACTION_OPEN, self.data.id);
	end
end




















Lua_ArtifactAttrItem = class("Lua_ArtifactAttrItem", Lua_ListCell);
function Lua_ArtifactAttrItem:ctor(p)
	self:superCall("ctor", p, "ArtifactAttrItem_skin");
end

function Lua_ArtifactAttrItem:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_ArtifactAttrItem:dispose()
	self:superCall("dispose");
end

function Lua_ArtifactAttrItem:setData(data)
	if data == nil then
		return;
	end

	self.icon:setAltas("common_altas_2", data.icon);
	if data.attrType == 1 then
		self.nameText.text = LanUtil.formateStr(350007, data.name);
	elseif data.attrType == 2 then
		self.nameText.text = LanUtil.formateStr(50008, data.name);
	else
		self.nameText.text = data.name;
	end
	self.nameText:resetSize();
	self.valueText.text = "+"..data.value;
	self.valueText:setLocation(self.nameText.posX + self.nameText.width + 10, 0, 0);
	self.valueText:resetSize();
end