checkRequire("Lua_CircleList");
Lua_ArtifactSkillList = class("Lua_ArtifactSkillList", Lua_CircleList);

function Lua_ArtifactSkillList:setData(data)
	self.cellsCount = 0;
	self.angleArr:clear();
	self:returnItem();
	if data == nil then
		return;
	end

	local len = data:getSize();
	local arr = Array();
	for i = 1, len do
		arr:add(data[i]);
	end
	for i = 1, len do
		arr:add(data[i]);
	end
	self:updateData(arr);
end

function Lua_ArtifactSkillList:getOffostY(angle)
	local offsetY = 0;
	local _angle = 0;
	local theta = 360 / self.cellsCount;
	local centerAngle;
	local prevAngle;
	local nextAngle;

	if self.angle < 0 then
		if angle > 0 then
			_angle = Mathf.Abs(angle + self.angle) % 360;
		else
			_angle = Mathf.Abs(angle - self.angle) % 360;
		end
	end

	if angle > 0 then
		centerAngle = (360 + self.angle) - 90;
		prevAngle = centerAngle - theta;
		nextAngle = centerAngle + theta;
		if _angle > prevAngle and _angle < centerAngle then
			offsetY = _angle - prevAngle;
		elseif _angle >= centerAngle and _angle < nextAngle then
			offsetY = nextAngle - _angle;
		else 
			offsetY = 0;
		end
	elseif angle < 0 then
		centerAngle = self.angle + 90;
		nextAngle = theta;
		prevAngle = 360 - nextAngle;
		if _angle > prevAngle then
			offsetY = _angle - prevAngle;
		elseif _angle >= centerAngle and _angle < nextAngle then
			offsetY = nextAngle - _angle;
		else 
			offsetY = 0;
		end
	end
	return offsetY * 2;
end