Lua_ArtifactUpSuccessWindow = class("Lua_ArtifactUpSuccessWindow", Lua_Window);
function Lua_ArtifactUpSuccessWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_ArtifactUpSuccessWindow";
	self.skinName = "ArtifactUpSuccessWindow_skin";
	self.showBlackMask = true;
	self.isClickClose = true;
end

function Lua_ArtifactUpSuccessWindow:buildShowItem()
	self:superCall("buildShowItem");
	self.winBg:SetDimensions(0, 0);

	self.attrList = Lua_DragList.new(self.content, 720, 220, Lua_AxisDefine.Vertical);
	self.attrList:setLocation(0, 55, 0);
	self.attrList:setListCell(Lua_ArtifactUpSuccessAttrItem, 720, 46, 1);
	self.attrList:setCellSpacing(0, 10);
end

function Lua_ArtifactUpSuccessWindow:dispose()
	if self.attrList ~= nil then
		self.attrList:dispose();
		self.attrList = nil;
	end
	if self.skillItem ~= nil then
		self.skillItem:dispose();
		self.skillItem = nil;
	end
	self:superCall("dispose");
end

function Lua_ArtifactUpSuccessWindow:showWin(param)
	self:superCall("showWin", param);

	self.name.text = LanUtil.formateStr(10040, param.name);
	self.prevLevel.text = LanUtil.formateStr(350000, tostring(param.prev_level));
	self.curLevel.text = LanUtil.formateStr(350000, tostring(param.prev_level + 1));

	local levelCfg = DataCenter.artifactUtil:getArtifactLvConfig(param.id * 1000 + param.prev_level);
	local roleAttrDic1 = {};
	local heroAttrDic1 = {};
	DataCenter.attributesUtil:getAttrDic(levelCfg, roleAttrDic1);
	DataCenter.attributesUtil:getAttrDic(levelCfg.prop_rate, heroAttrDic1);

	levelCfg = DataCenter.artifactUtil:getArtifactLvConfig(param.id * 1000 + param.prev_level + 1);
	local roleAttrDic2 = {};
	local heroAttrDic2 = {};
	DataCenter.attributesUtil:getAttrDic(levelCfg, roleAttrDic2);
	DataCenter.attributesUtil:getAttrDic(levelCfg.prop_rate, heroAttrDic2);

	local arr = Array();
	DataCenter.roleUtil:getAttrArr2(roleAttrDic1, roleAttrDic2, 1, arr);
	DataCenter.roleUtil:getAttrArr2(heroAttrDic1, heroAttrDic2, 2, arr);

	arr:sort("sortNum", false);
	self.attrList:setArrayData(arr);
	self.attrList.canDrag = not self.attrList.bDragEnd;

	if levelCfg.unlock_skill_show == nil or levelCfg.unlock_skill_show <= 0 then
		self.winBg:setUrl("/images/common/ui_common_window_038.png");
		self.text_2:setEnable(false);
	else
		self.winBg:setUrl("/images/common/ui_common_window_037.png");
		self.text_2:setEnable(true);

		if self.skillItem == nil then
			self.skillItem = Lua_ArtifactUpSuccessSkillItem.new(self.content);
			self.skillItem:setLocation(0, -190, 0);
		end
		local data = Lua_SkillConfigData.getConfigData(levelCfg.unlock_skill_show);
		self.skillItem:setData(data);
	end
end




















Lua_ArtifactUpSuccessAttrItem = class("Lua_ArtifactUpSuccessAttrItem", Lua_ListCell);
function Lua_ArtifactUpSuccessAttrItem:ctor(p)
	self:superCall("ctor", p, "ArtifactUpSuccessAttrItem_skin");
end

function Lua_ArtifactUpSuccessAttrItem:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_ArtifactUpSuccessAttrItem:dispose()
	self:superCall("dispose");
end

function Lua_ArtifactUpSuccessAttrItem:setCellSeqIndex(idx)
	self:superCall("setCellSeqIndex", idx);
	self.bg:setEnable(self.cellSeqIndex % 2 == 0);
end

function Lua_ArtifactUpSuccessAttrItem:setData(data)
	if data.attrType == 1 then
		self.nameText.text = LanUtil.formateStr(350007, data.name);
	elseif data.attrType == 2 then
		self.nameText.text = LanUtil.formateStr(350008, data.name);
	else
		self.nameText.text = data.name;
	end
	self.valueText_1.text = data.value;
	self.valueText_2.text = data.nextValue;
end




















Lua_ArtifactUpSuccessSkillItem = class("Lua_ArtifactUpSuccessSkillItem", Lua_ListCell);
function Lua_ArtifactUpSuccessSkillItem:ctor(p)
	self:superCall("ctor", p, "ArtifactUpSuccessSkillItem_skin");
end

function Lua_ArtifactUpSuccessSkillItem:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_ArtifactUpSuccessSkillItem:dispose()
	self:superCall("dispose");
end

function Lua_ArtifactUpSuccessSkillItem:setData(data)
	self.icon:setAltas(data.atlas, data.sprite);
	self.icon:resetSize();
	self.nameText.text = data.name;
	self.desText.text = data.des;
end